# uudecode
#
# 25-Jun-92 weber@eitech.com updated for new parameter format
# 29-May-92 weber@eitech.com
#
# Copyright (c)  1992 Enterprise Integration Technologies Corporation
#
# Permission to use, copy, modify, distribute, and sell this software and 
# its documentation for any purpose is hereby granted without fee, provided
# that (i) the above copyright notices and this permission notice appear in
# all copies of the software and related documentation, and (ii) the name of
# Enterprise Integration Technologies Corporation may not be used in any 
# advertising or publicity relating to the software without the specific, 
# prior written permission of Enterprise Integration Technologies Corporation.
# 
# THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
# WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
#
# IN NO EVENT SHALL ENTERPRISE INTEGRATION TECHNOLOGIES CORPORATION  BE
# LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
# ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
# PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
# THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
#
# This service scans through a message body for uudecode source, and
# sends what it found back to the requestor.  If the input is a multipart, it
# scans through the last body in the multipart.
#
proc uudecode {switches envelope inputs} {
      if {[getfield $inputs TYPE] == "multipart"} {
	set parts [getfield $inputs PARTS]
	return [uudecode $switches $envelope [lindex $parts [expr [llength $parts] - 1]]]
      } {
	set src [getfield $inputs FILE]
    	exec awk "/^begin /,/^end\$/" $src | uudecode
	set sink [glob [exec awk "/^begin /{print \$3}" $src]]
        if {[regexp "(.*)\.Z$" $sink match submatch]} {
	  exec uncompress $sink
	  setfield response FILE $submatch
	} {
	  setfield response FILE $sink
	}
	return [mailout [turnaround $envelope] $response]
      }
}
